#include <iostream>
#include "library/seqinfileenumerator.hpp"
#include "library/intervalenumerator.hpp"
#include "library/summation.hpp"
#include "library/maxsearch.hpp"

using namespace std;

class Multiply : public Summation<int>
{
    void init()
    {
        *_result = 1;
    }
    void add(const int& e)
    {
        *_result *= e;
    }
};

struct struktogram
{
    string nev;
    int loopnumber;
};

istream& operator>>(istream& in, struktogram& s)
{
    in >> s.nev;
    in >> s.loopnumber;
    return in;
}

class MyMaxSearch : public MaxSearch<struktogram,int>
{
    bool cond(const struktogram& s) const override
    {
        return s.nev[0] == 'k';
    }
    int func(const struktogram& s) const override
    {
        return s.loopnumber;
    }
};

int main()
{
    Multiply m;
    IntervalEnumerator e(1,10);
    m.addEnumerator(&e);
    m.run();
    cout << m.result() << endl;

    SeqInFileEnumerator<struktogram> file("input.txt");
    MyMaxSearch ms;
    ms.addEnumerator(&file);
    ms.run();
    cout << ms.optElem().nev << endl;

    //cout << "Hello world!" << endl;
    return 0;
}
